;; original name logistics.easy
;;

(define (problem easy2)
    (:domain logistics-metric)
    (:length (:parallel 9))
    (:domain-variables
	(?dist[la-airport,la-airport] 0)
	(?dist[bos-airport,bos-airport] 0)
	(?dist[pgh-airport,pgh-airport] 0)
	(?dist[la-airport,bos-airport] 3000)
	(?dist[la-airport,pgh-airport] 2500)
	(?dist[pgh-airport,la-airport] 2500)
	(?dist[bos-airport,la-airport] 3000)
	(?dist[pgh-airport,bos-airport] 800)
	(?dist[bos-airport,pgh-airport] 800)

	;; Both airplanes can make the east coast - west coast runs.
	(?capacity[airplane1] 2000)
	(?capacity[airplane2] 2000)

	(?capacity[pgh-truck] 100)
	(?capacity[bos-truck] 100)
	(?capacity[la-truck] 100)
	(?truck_trip 20)
	(?airplane_trip 50)
	(?plane_mpg 3) - float
	(?fuel[airplane1] 100)
	(?fuel[airplane2] 100)
	(?fuel[pgh-truck] 20)
	(?fuel[bos-truck] 20)
	(?fuel[la-truck] 20)
	             - fluent)
    (:objects
        package1
        package2
	     - OBJ

        airplane1
        airplane2
	     - AIRPLANE

        pgh
        bos
	   la
	     - CITY

        pgh-truck
        bos-truck
	   la-truck
          - TRUCK

        pgh-po
        bos-po
	   la-po
	     - LOCATION

        pgh-airport
        bos-airport
	   la-airport
	     - AIRPORT
    )
    (:init
	   (depot pgh-airport)
	   (depot bos-airport)
	   (depot la-airport)

        (in-city pgh-po pgh)
        (in-city pgh-airport pgh)

        (in-city bos-po bos)
        (in-city bos-airport bos)

        (in-city la-po la)
        (in-city la-airport la)

        (at package1 pgh-po)
        (at package2 pgh-po)

        (at airplane1 pgh-airport)
        (at airplane2 pgh-airport)

        (at bos-truck bos-po)
        (at pgh-truck pgh-po)
        (at la-truck la-po)
    )
    (:goal (and
        (at package1 bos-po)
        (at package2 la-po)
    ))
)

