;; Camel domain from cocktail party question proposed by Marc Friedman
;;

;; I have to deal with having sets of bananas reach certain
;; points. Ideas: each banana is an object (bad), each banana is
;; numbered and its position reffed in an array, there are banana
;; "stashes" which the camel moves and which can contain bananas
;; (objects or numbers).


(define (domain camel)
  ;; Note: I have _not_ added in the proper slew of requirements,
  ;;       nor are there any preexisting ones that really match up.
  (:requirements :strips) 

  ;; Type heirarchy (TYPE1 TYPE2 ... - SUPERTYPE ...)
  (:types STASH - OBJECT)

  ;; Do _everything_. Move right by ?rightDist, left by ?leftDist,
  ;; grab from your starting location. Unload bananas at the end.
  (:action MOVE-AND-LOAD
		 :parameters (?stashFrom - STASH
				    ?stashTo   - STASH)
		 :fluent-parameters ( ?rightDist ?leftDist ?numLoad ?numUnload )
		 :precondition
		 (and (not (eq ?stashFrom ?stashTo))
			 (test ?rightDist >= 0)
			 (test ?leftDist >= 0)
			 (test ?numLoad >= 0)
			 (test ?numUnload >= 0)
			 (test ?camelLoc = ?stashLoc[?stashFrom])
			 (test ?numLoad <= ?stashSize[?stashFrom])
			 (test (?rightDist + ?leftDist) * ?camelMPB <= 
				  ?camelLoad + ?numLoad)
			 (test ?camelLoad + ?numLoad <=
				  ?maxCamelLoad)
			 (test ?numUnload <=
				  ?camelLoad + ?numLoad - 
				  (?rightDist + ?leftDist) * ?camelMPB)
			 (test ?stashSize[?stashTo] = 0)
			 )
		 :effect
		 (and (set ?camelLoc ?camelLoc + ?rightDist - ?leftDist)
			 (set ?camelLoad ?camelLoad + ?numLoad - ?numUnload -
				 (?rightDist + ?leftDist) * ?camelMPB)
			 (set ?stashSize[?stashFrom] ?stashSize[?stashFrom] - ?numLoad)
			 (set ?stashSize[?stashTo] ?stashSize[?stashTo] + ?numUnload)
			 (set ?stashLoc[?stashTo] ?camelLoc + ?rightDist - ?leftDist)))
  )






