;; original name rocket_ext.a
;; (:length (:parallel 7))
;; optimal
;;
;; Distances thanks to Altavista's mileage chart. Of course, these are
;; as the crow flies and not necessarily correct for how airplanes would
;; fly them, but they should be a reasonable approximation.

(define (problem log002)
  (:domain logistics-metric)
  (:length (:parallel 7))
  (:domain-variables
   (?dist[lon-airport,lon-airport] 0)
   (?dist[par-airport,par-airport] 0)
   (?dist[jfk-airport,jfk-airport] 0)
   (?dist[bos-airport,bos-airport] 0)
   (?dist[lon-airport,par-airport] 1)
   (?dist[par-airport,lon-airport] 1)
   (?dist[lon-airport,bos-airport] 1)
   (?dist[bos-airport,lon-airport] 1)
   (?dist[bos-airport,par-airport] 1)
   (?dist[par-airport,bos-airport] 1)
   (?dist[bos-airport,jfk-airport] 1)
   (?dist[jfk-airport,bos-airport] 1)
   (?dist[jfk-airport,lon-airport] 1)
   (?dist[lon-airport,jfk-airport] 1)
   (?dist[jfk-airport,par-airport] 1)
   (?dist[par-airport,jfk-airport] 1)
   (?capacity[airplane1] 4000)
   (?capacity[airplane2] 4000)
   (?truck-trip 1)
   (?airplane_trip 1)
   (?plane_mpg 3) -float
   (?fuel[airplane1] 10000)
   (?fuel[airplane2] 10000) - fluent)
  (:objects 
   mxf
   avrim
   alex
   jason
   pencil
   paper
   april
   michelle
   betty
   lisa - OBJ
   
   airplane1 
   airplane2 - AIRPLANE
   
   lon-airport 
   par-airport 
   jfk-airport 
   bos-airport - AIRPORT
   
   lon 
   par 
   nyc
   bos - CITY)
  (:init
   (in-city lon-airport lon)
   (in-city bos-airport bos)
   (in-city jfk-airport nyc)
   (in-city par-airport par)
   
   (depot lon-airport)
   (depot jfk-airport)
   (depot par-airport)
   (depot bos-airport)

   (at airplane1 jfk-airport)
   (at airplane2 bos-airport)
   
   (at mxf par-airport)
   (at avrim par-airport)
   (at alex par-airport)
   (at jason jfk-airport)
   (at pencil lon-airport)
   (at paper lon-airport)
   (at michelle lon-airport)
   (at april lon-airport)
   (at betty lon-airport)
   (at lisa lon-airport)
   )
  (:goal (and 
		(at mxf bos-airport)
		(at avrim jfk-airport)
		(at pencil bos-airport)
		(at alex jfk-airport)
		(at april bos-airport)
		(at lisa par-airport)
		(at michelle jfk-airport)
		(at jason bos-airport)
		(at paper par-airport)
		(at betty jfk-airport)
		)
	    )
  )

