;; missionaries and natives domain
;;
;; modified from domain obtained from Jana Koehler

(define (domain m-and-n)
  (:requirements :strips) 
  (:types SIDE PERSON - OBJECT MISSIONARY NATIVE - PERSON)
  (:predicates (at-boat ?side - SIDE)
			(at ?p - PERSON ?side - SIDE)
			(boarded ?p - PERSON)
			)
  (:action BOARD-NATIVE
		 :parameters
		 (?side - SIDE
		  ?p - NATIVE)
		 :precondition
		 (and (at-boat ?side) (at ?p ?side)
			 (test ?boarded_native' + ?boarded_miss' <= ?capacity)
			 (not (boarded ?p)))
		 :effect
		 (and (not (at ?p ?side))
			 (boarded ?p)
			 (influence ?boarded_native 1)))
  (:action BOARD-MISSIONARY
		 :parameters
		 (?side - SIDE
		  ?p - MISSIONARY)
		 :precondition
		 (and (at-boat ?side) (at ?p ?side)
			 (test ?boarded_native' + ?boarded_miss' <= ?capacity)
			 (not (boarded ?p)))
		 :effect
		 (and (not (at ?p ?side))
			 (boarded ?p)
			 (influence ?boarded_miss 1)))
  (:action DEBOARD-NATIVE
		 :parameters
		 (?side - SIDE
		  ?p - NATIVE)
		 :precondition
		 (and (at-boat ?side) (boarded ?p))
		 :effect
		 (and (not (boarded ?p))
			 (at ?p ?side)
			 (influence ?boarded_native -1)))
  (:action DEBOARD-MISSIONARY
		 :parameters
		 (?side - SIDE
		  ?p - MISSIONARY)
		 :precondition
		 (and (at-boat ?side) (boarded ?p))
		 :effect
		 (and (not (boarded ?p))
			 (at ?p ?side)
			 (influence ?boarded_miss -1)))
  (:action CROSS
		 :parameters
		 (?from
		  ?to   - SIDE)
		 :precondition
		 (and (at-boat ?from)
			 (test ?boarded_native + ?boarded_miss >= 1)
			 (or (test ?num_miss'[?from] <= ?num_native'[?from])
				(test ?num_native'[?from] = 0))
			 (or (and
				 (test ?boarded_miss <= ?boarded_native)
				 (test ?num_miss'[?to] <= ?num_native'[?to]))
				(and (test ?boarded_native = 0)
					(or (test ?num_miss'[?to] <= ?num_native'[?to])
					    (test ?num_native'[?to] = 0)))))
		 :effect
		 (and (at-boat ?to)
			 (not (at-boat ?from))
			 (influence ?num_miss[?from] -?boarded_miss)
			 (influence ?num_miss[?to] ?boarded_miss)
			 (influence ?num_native[?from] -?boarded_native)
			 (influence ?num_native[?to] ?boarded_native)))
  )
