;; missionaries and natives domain
;;
;; modified from domain obtained from Jana Koehler

(define (domain m-and-n)
  (:requirements :strips) 
  (:types SIDE PERSON - OBJECT MISSIONARY NATIVE - PERSON)
  (:predicates (at-boat ?side - SIDE)
			(at ?p - PERSON ?side - SIDE)
			(boarded ?p - PERSON)
			)
  (:action BOARD-NATIVE
		 :parameters
		 (?side - SIDE
		  ?p - NATIVE)
		 :precondition
		 (and (at-boat ?side) (at ?p ?side)
			 (test ?boarded_native + ?boarded_miss <= ?capacity)
			 (not (boarded ?p)))
		 :effect
		 (and (not (at ?p ?side))
			 (boarded ?p)
			 (set ?boarded_native ?boarded_native + 1)))
  (:action BOARD-MISSIONARY
		 :parameters
		 (?side - SIDE
		  ?p - MISSIONARY)
		 :precondition
		 (and (at-boat ?side) (at ?p ?side)
			 (test ?boarded_native + ?boarded_miss <= ?capacity)
			 (not (boarded ?p)))
		 :effect
		 (and (not (at ?p ?side))
			 (boarded ?p)
			 (set ?boarded_miss ?boarded_miss + 1)))
  (:action DEBOARD-NATIVE
		 :parameters
		 (?side - SIDE
		  ?p - NATIVE)
		 :precondition
		 (and (at-boat ?side) (boarded ?p))
		 :effect
		 (and (not (boarded ?p))
			 (at ?p ?side)
			 (set ?boarded_native ?boarded_native - 1)))
  (:action DEBOARD-MISSIONARY
		 :parameters
		 (?side - SIDE
		  ?p - MISSIONARY)
		 :precondition
		 (and (at-boat ?side) (boarded ?p))
		 :effect
		 (and (not (boarded ?p))
			 (at ?p ?side)
			 (set ?boarded_miss ?boarded_miss - 1)))
  (:action CROSS
		 :parameters
		 (?from
		  ?to   - SIDE)
		 :precondition
		 (and (at-boat ?from)
			 (test ?boarded_native + ?boarded_miss >= 1)
			 (or (test ?num_miss[?from] - ?boarded_miss <=
					 ?num_native[?from] - ?boarded_native)
				(test ?num_native[?from] - ?boarded_native = 0))
			 (or (test ?num_miss[?to] + ?boarded_miss <=
					 ?num_native[?to] + ?boarded_native)
				(test ?num_native[?to] + ?boarded_native = 0))
			 (or (test ?boarded_miss <= ?boarded_native)
				(test ?boarded_native = 0)))
		 :effect
		 (and (at-boat ?to)
			 (not (at-boat ?from))
			 (set ?num_miss[?from] ?num_miss[?from] - ?boarded_miss)
			 (set ?num_miss[?to] ?num_miss[?to] + ?boarded_miss)
			 (set ?num_native[?from] ?num_native[?from] - ?boarded_native)
			 (set ?num_native[?to] ?num_native[?to] + ?boarded_native)))
  )
