;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; truck world with pickup/putdown
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (domain truck)
  (:requirements :strips)
  (:types CONTAINER LOC THING)
  (:domain-variables
   (?fast_speed 60)
   (?slow_speed 30)
   (?fast_mpg 20)
   (?slow_mpg 60) - float
   (?time 0) - fluent)
  (:action slow-move
		 :parameters (?from ?to - LOC)
		 :precondition (and (att ?from)
						(test (?fuel - ?dist[?from,?to] / ?slow_mpg) 
							 >= 0)
						(connected ?from ?to))
		 :effect (and (not (att ?from))
				    (att ?to)
				    (set ?fuel (?fuel - ?dist[?from,?to] / ?slow_mpg))
				    (set ?time (?time + ?dist[?from,?to] / ?slow_speed))))
  (:action fast-move
		 :parameters (?from ?to - LOC)
		 :precondition (and (att ?from)
						(test (?fuel - ?dist[?from,?to] / ?fast_mpg) 
							 >= 0)
						(connected ?from ?to))
		 :effect (and (not (att ?from))
				    (att ?to)
				    (set ?fuel (?fuel - ?dist[?from,?to] / ?fast_mpg))
				    (set ?time (?time + ?dist[?from,?to] / ?fast_speed))))
  (:action pick-up
		 :parameters(?obj - THING ?loc - LOC)
		 :precondition (and (att ?loc)
						(at ?obj ?loc))
		 :effect (and (not (at ?obj ?loc))
				    (in-truck ?obj)))
  (:action put-down
		 :parameters(?obj - THING ?loc - LOC)
		 :precondition (and (in-truck ?obj)
						(att ?loc))
		 :effect (and (not (in-truck ?obj))
				    (at ?obj ?loc)))
  (:predicates (att ?loc - LOC)
			(at ?obj - THING ?loc - LOC)
			(connected ?x ?y - LOC)
			(in-truck ?obj - THING))

)


