#ifndef Random_h
#define Random_h

///////////////////////////////////////////////////////////////////////////////
// Initializes random number generation

/////////////////
// OS Includes
extern "C" {
int random();
}

//////////////
// Includes
#include "LightweightTypes.h"

/////////////
// Defines

////////////////////////
// Class Declarations
class Random {
public:
  static void vInitRandom(long);
  static double dRandom1() {return ((double)(random())/((double)iHalfOpen));} // [0-1.0)
  static double dRandom2() {return ((double)(random()+1)/((double)iHalfOpen));}  // (0-1.0]
  static double dRandom3() {return ((double)(random())/((double)iClosed));}  // [0-1.0]
  static double dRandom4() {return ((double)(random()+1)/((double)iOpen));}  // (0-1.0)
  static unsigned int iRandom(unsigned int iMax_) {return ((unsigned int)random())%iMax_;}
  static unsigned long lRandom(unsigned long lMax_) {return ((unsigned long)random())%lMax_;}
  static boolean bRandom() {return (boolean)(random()%2);}
  static unsigned long iHalfOpen;
  static unsigned long iClosed;
  static unsigned long iOpen;
};

///////////////////////////////////////////////////////////////////////////////
// Class Definitions

///////////////////////////////////////////////////////////////////////////////
// Inlines

#endif // Random_h

