#ifndef SATInstance_h
#define SATInstance_h

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// SATInstance

/////////////////
// OS Includes

//////////////
// Includes
#include "ClauseList.h"
#include "shared.h"

/////////////
// Defines

////////////////////////
// Class Declarations
class istream;
class ClConstraint;
class ClVariable;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Class Definitions

class SATInstance : public ClauseList {
public:
  SATInstance() : aVariables(0), aConstraints(0) {}

  void vOutput();
  void vOutputDimacs();

  boolean bReadDimacs(char* aFileName_);
  boolean bReadDimacs(istream&);

  boolean bInit(const vector<vector<VAR_OCC> > & clauses, int maxLit,
			 const vector<pair<int,string> > & constraints, int maxRVar);
  boolean bInit(const vector<vector<VAR_OCC> > & clauses, int maxLit);

  // static data
  static SATInstance xSATInstance;
  int iVariableCount;
  int iRVariableCount;

  // Wolf - added to keep track of constraints.
  ClVariable * aVariables;
  ClConstraint* * aConstraints;
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Inlines

#endif // SATInstance_h


